//#define _GLIBCXX_DEBUG
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx")
#include<bits/stdc++.h>
//#define int long long
#define endl '\n'
using namespace std;
vector<int> g[100001];
int n;
int mp[100001];
//map<pair<int,int>,bool>memo;
//bool is_tl(){
//    double time=(1.0*clock()/CLOCKS_PER_SEC);
//    return time>=0.985;
//}
bool used[100001];
void dfs(int v,int c_ti=1){
  //  if(is_tl()){
  //      puts("NO");
  //      exit(0);
  //  }
    if(c_ti==n){
        for(auto i:g[v]){
            if(i==1){
                mp[v]=1;
                puts(("YES"));
                v=1;
                putchar('1');
                putchar(' ');
                while(mp[v]!=1){
                    printf("%d ",mp[v]);
                    v=mp[v];
                }
                puts("1 ");
                exit(0);
            }
        }
        return;
    }
    for(auto i:g[v]){
        if(!used[i]){
            used[i]=true;mp[v]=i;
            dfs(i,c_ti+1);
            mp[v]=0;
            used[i]=false;
        }
    }
    return;
}
void Bogdan(){
    //const time_t timer=time(NULL);
    int m;
    scanf("%d %d",&n,&m);
    int l,r;
    for(int i=0;i<m;i++){
        scanf("%d %d",&l,&r);
        g[l].push_back(r);
    }
    for(int i=1;i<=n;i++){
        if(!g[i].size()){
           puts("NO\n");
            return;
        }
    }
    dfs(1);
    puts(("NO"));
}
/*
*/
int main(){
    int t=1,n;
   // cin>>t;
    while(t--){
        Bogdan();
    }
}
